#!/usr/bin/env ruby

class Book
  
  def page_first
    @page_count = 0
  end
  
  attr :page_count, true
  
  def page_path
    "page.dat"
  end
  
  def load_page_count_limit
    @page_count_limit =
    begin
      File.open(page_path){|f| f.gets.chomp.to_i }
    rescue
      0
    end
  end
  
  attr :page_count_limit
  
  def each
    0.upto(@page_count_limit-1){|@page_count| yield }
  end
  
  def initialize
    load_page_count_limit
    page_first
  end
  
  def Book.open(page_count=0)
    book = new
    book.page_count = page_count
    book
  end
  
  def save_page_count_limit
    File.open(page_path, 'w'){|f| f.puts @page_count_limit }
  end
  
  def path_list_path
    "path.#@page_count.dat"
  end
  
  def page_limit_here
    @page_count_limit = @page_count+1
  end
  
  def page_reset
    @path_list_file = File.open(path_list_path, 'w')
    page_limit_here
  end
  
  def page_close
    @path_list_file.close
    save_page_count_limit
  end
  
  def close
    page_close
  end
  
  def page_put_path(path)
    @path_list_file.puts [path, 0].join("\t")
  end
  
  def page_new
    @page_count+= 1
    page_close
    page_reset
  end
  
  def path_list_load
    path_list = []
    File.open(path_list_path) do |f|
      path_index = 0
      while line = f.gets
        path_list[path_index] = line.chomp.split("\t")[0]
        path_index+= 1
      end
    end
    path_list
  end
  
  def path_list_update
    path_list = {}
    src = path_list_path
    unless test ?e, src
      return path_list
    end
    tmp = src + '~'
    File.rename src, tmp
    File.open(tmp, 'r'){|f|
    File.open(src, 'w'){|o|
      path_index = 0
      while line = f.gets
        path, mtime = line.chomp.split("\t")
        mtime = mtime.to_i
        if File.stat(path).mtime > mtime
          path_list[path_index] = path
        end
        path_index+= 1
        o.puts [path, File.stat(path).mtime.to_i].join("\t")
      end
    }}
    File.delete tmp
    path_list
  end
  
  def pset_path
    "pset.#@page_count.dat"
  end
  
  def pset_reset
    @pset_file =
    begin
      File.open(pset_path, 'rb+')
    rescue
      File.open(pset_path, 'wb+')
    end
  end
  
  def pset_rewrite
    @pset_file =
      File.open(pset_path, 'wb+')
  end
  
  def pset_append
    @pset_file =
      File.open(pset_path, 'ab+')
  end
  
  def pset_close
    @pset_file.close
  end
  
  def pset_load(pos)
    begin
      @pset_file.pos = pos
      Marshal.load(@pset_file)
    rescue
      {}
    end
  end
  
  def pset_save(set)
    if set.empty?
      nil
    else
      pset_append
      pos = @pset_file.pos
      Marshal.dump(set, @pset_file)
      pos
    end
  end
  
  def wpos_path
    "wpos.#@page_count.dat"
  end
  
  def wpos_load
    begin
      File.open(wpos_path, 'rb'){|i| Marshal.load(i) }
    rescue
      {}
    end
  end
  
  def wpos_save(wpos)
    File.open(wpos_path, 'wb'){|o| Marshal.dump(wpos, o) }
  end
  
  def word_set_load(wpos)
    word_set = {}
    pset_reset
    wpos.each{|word, pos| word_set[word] = pset_load(pos) }
    pset_close
    word_set
  end
  
  def word_set_save(word_set)
    wpos = {}
    pset_rewrite
    word_set.each do |word, pset|
      wpos[word] = @pset_file.pos
      Marshal.dump(pset, @pset_file)
    end
    pset_close
    wpos
  end
  
end
