#!/usr/bin/env ruby

module DojoFind
  
  def join_set(xpos, ypos, d)
    xset = pset_load(xpos)
    yset = pset_load(ypos)
    
    return nil if xset.empty?
    return nil if yset.empty?
    set = {}
    (xset.keys & yset.keys).each do |path_index|
      x = xset[path_index]
      y = yset[path_index]
      next if x.nil? || x.empty?
      next if y.nil? || y.empty?
      
      xi = 0
      yi = 0
      while true
        case x[xi] + d <=> y[yi]
        when 0
          if set[path_index].nil?
             set[path_index] = []
          end
          set[path_index].push x[xi]
          xi+= 1; break if xi >= x.size
          yi+= 1; break if yi >= y.size
        when 1
          yi+= 1; break if yi >= y.size
        else
          xi+= 1; break if xi >= x.size
        end
      end
    end
  # p set
    pset_save(set)
  end
  
  def wide_at(string, index)
    i = 0
    string.scan(/./m) do |char|
      break if i == index || i == index+1
      i+= char.size
    end
    i - index
  end
  
  def compute(wpos, string)
    puts "compute #{string}"
    wpos[string] or
    begin
      divlen = string.length/2
      divlen-= wide_at(string, divlen)
      wpos[string] = join_set(
        compute(wpos, string[0...divlen]),
        compute(wpos, string[divlen..-1]),
        divlen) if divlen > 0
      wpos[string]
    end
  end
  
end
